property UpCM, DownCM, PressCM, UpNum, DownNum, PressNum, button_active, RunCommand

on mouseDown me
  puppetSound("NyKnap")
end

on mouseUp me
  set the member of sprite the spriteNum of me to member the DownCM of me
  do(the RunCommand of me)
end

on mouseEnter me
  if not (the button_active of me) then
    set the member of sprite the spriteNum of me to member the DownCM of me
    set the button_active of me to 1
  end if
end

on mouseLeave me
  if the button_active of me then
    set the member of sprite the spriteNum of me to member the UpCM of me
    set the button_active of me to 0
  end if
end

on mouseUpOutSide me
  set the member of sprite the spriteNum of me to member the UpCM of me
  set the button_active of me to 0
end

on beginSprite me
  set the UpCM of me to the member of sprite the spriteNum of me
  set the UpNum of me to the number of member UpCM
  set the DownNum of me to the number of member DownCM
  set the button_active of me to 0
end

on getPropertyDescriptionList
  if the currentSpriteNum = 0 then
    set memdefault to 0
  else
    set memref to the member of sprite the currentSpriteNum
    set castLibNum to the castLibNum of memref
    set memdefault to member "Lys Knap" of castLib "VConst"
  end if
  set p_list to [#DownCM: [#comment: "Hilite Image:", #format: #graphic, #default: memdefault], #RunCommand: [#comment: "Command to run:", #format: #text, #default: "beep"]]
  return p_list
end

on getBehaviorDescription
  return "Makes a sprite work as a pushbutton with automatic highlighting and mouse tracking. The sprite's initial castmember represents the button's normal state." & RETURN & "PARAMETERS:" & RETURN & "• Hilite Image - Choose the cast member to display when the button is pressed. The default value is the cast member immedietly following the sprite's current cast member." & RETURN & "• Activated image - image displayed when the user clicks the button. Default value is the cast member number two from the current cast member." & RETURN & "• Operation to execute. This command will be run on a MouseUp event (user releases mouse button over this button). Use it to switch frame, run external programs etc."
end
