property MouseCommand, MouseCommand2
global CurrentStep

on new me
  set the visible of sprite the currentSpriteNum to 1
  set the visible of sprite (the currentSpriteNum + 1) to 0
  set the visible of sprite (the currentSpriteNum + 2) to 0
end

on mouseEnter me
  set the visible of sprite (the currentSpriteNum + 1) to 1
  set the visible of sprite (the currentSpriteNum + 2) to 1
end

on mouseLeave me
  set the visible of sprite (the currentSpriteNum + 1) to 0
  set the visible of sprite (the currentSpriteNum + 2) to 0
end

on mouseDown
end

on mouseUp
  if voidp(MouseCommand) then
    set MouseCommand to "beep"
  end if
  if voidp(MouseCommand2) then
    set MouseCommand2 to "beep"
  end if
  if CurrentStep = 0 then
    do(MouseCommand)
  else
    if CurrentStep = 1 then
      do(MouseCommand2)
    end if
  end if
end

on getBehaviorDescription
  return "Hilite the next two sprites on the stage. On mouseclick, jump to an appropriate handler. (This is a specialized behaviour for emulating sliders)."
end

on getPropertyDescriptionList
  set p_list to [#MouseCommand: [#format: #string, #comment: "On mouseclick execute this", #default: "beep"], #MouseCommand2: [#format: #string, #comment: "On mouseclick execute this", #default: "beep"]]
  return p_list
end
