property ItemState

on new me
  getPropertyDescriptionList()
  set the visible of sprite the currentSpriteNum to 1
  set the visible of sprite (the currentSpriteNum + 1) to 0
  set the visible of sprite (the currentSpriteNum + 2) to 0
  set the visible of sprite (the currentSpriteNum + 3) to ItemState
end

on mouseEnter me
  set the visible of sprite (the currentSpriteNum + 1) to 1
end

on mouseLeave me
  set the visible of sprite (the currentSpriteNum + 1) to 0
end

on mouseDown
end

on mouseUp
  set Seen to the visible of sprite (the currentSpriteNum + 3)
  set the visible of sprite (the currentSpriteNum + 3) to 1 - Seen
end

on getBehaviorDescription
  return "Hilite two fields for descriptions. Third field is intended for a toggling bitmap (checkboxes and such). The paramitra is 1 for default on, 0 for default off."
end

on getPropertyDescriptionList
  set p_list to [#ItemState: [#default: ItemState, #format: #integer, #comment: "Initial state", #range: [#min: 0, #max: 1]]]
  return p_list
end
