property SleepImage, TargetSprite, startPos, IncorrectCommand, correctCommand, DescribeSprite
global Errorcount

on new me
  set Errorcount to -1
  set the visible of sprite (the spriteNum of me - 1) to 0
  set the visible of sprite the spriteNum of me to 1
  set the visible of sprite (the spriteNum of me + 1) to 0
  set the visible of sprite (the spriteNum of me + 2) to 0
  if the locV of sprite (the spriteNum of me - 1) > 0 then
    set the locV of sprite (the spriteNum of me - 1) to the locV of sprite (the spriteNum of me - 1) - 500
    set the locV of sprite (the spriteNum of me + 1) to the locV of sprite (the spriteNum of me + 1) - 500
    set the locV of sprite (the spriteNum of me + 2) to the locV of sprite (the spriteNum of me + 2) - 500
  end if
  set the SleepImage of me to the memberNum of sprite the spriteNum of me
end

on mouseDown me
  if the locV of sprite (the spriteNum of me - 1) > 0 then
    set the locV of sprite (the spriteNum of me - 1) to the locV of sprite (the spriteNum of me - 1) - 500
    set the locV of sprite (the spriteNum of me + 1) to the locV of sprite (the spriteNum of me + 1) - 500
    set the locV of sprite (the spriteNum of me + 2) to the locV of sprite (the spriteNum of me + 2) - 500
  end if
  set startPos to the loc of sprite the spriteNum of me
  repeat while the stillDown = 1
    set the loc of sprite the spriteNum of me to point(the mouseH, the mouseV)
    updateStage()
  end repeat
end

on mouseEnter me
  set the memberNum of sprite the spriteNum of me to SleepImage + 1
  set the visible of sprite (the spriteNum of me - 1) to 1
  set the visible of sprite (the spriteNum of me + 1) to 1
  set the visible of sprite (the spriteNum of me + 2) to 1
  if the locV of sprite (the spriteNum of me - 1) < 0 then
    set the locV of sprite (the spriteNum of me - 1) to the locV of sprite (the spriteNum of me - 1) + 500
    set the locV of sprite (the spriteNum of me + 1) to the locV of sprite (the spriteNum of me + 1) + 500
    set the locV of sprite (the spriteNum of me + 2) to the locV of sprite (the spriteNum of me + 2) + 500
  end if
  updateStage()
end

on mouseLeave me
  if the locV of sprite (the spriteNum of me - 1) > 0 then
    set the locV of sprite (the spriteNum of me - 1) to the locV of sprite (the spriteNum of me - 1) - 500
    set the locV of sprite (the spriteNum of me + 1) to the locV of sprite (the spriteNum of me + 1) - 500
    set the locV of sprite (the spriteNum of me + 2) to the locV of sprite (the spriteNum of me + 2) - 500
  end if
  set the memberNum of sprite the spriteNum of me to SleepImage
  updateStage()
end

on mouseUp me
  set the memberNum of sprite the spriteNum of me to SleepImage
  if sprite the spriteNum of me intersects sprite(the TargetSprite of me) then
    do(the correctCommand of me)
    set the loc of sprite the spriteNum of me to startPos
  else
    if Errorcount = -1 then
      set Errorcount to 0
      puppetSound("Venlig lærer")
    else
      set Errorcount to Errorcount + 1
      if Errorcount >= 5 then
        puppetSound("Vrissen Lærer II")
        set Errorcount to 0
      else
        do(the IncorrectCommand of me)
      end if
    end if
    set the loc of sprite the spriteNum of me to startPos
  end if
end

on getBehaviorDescription
  return "Creates sprites that can be dropped on any other [user specified] sprite. You can define the target sprite, " && RETURN & "whether the dragged sprite snaps back to it's start position, and handlers to run if the drop was on or off target."
end

on getPropertyDescriptionList
  if voidp(TargetSprite) then
    set TargetSprite to 1
  end if
  set p_list to [#TargetSprite: [#default: TargetSprite, #format: #integer, #comment: "Target Sprite Number", #range: [#min: 1, #max: 120]], #correctCommand: [#format: #string, #comment: "The handler to run if dropped on the target", #default: "go to frame Her"], #IncorrectCommand: [#format: #string, #comment: "The handler to run if dropped off the target", #default: "puppetsound Twang1"]]
  return p_list
end
