property startPos, StartX, StartY, DestX, DestY

on new me
  set the visible of sprite the spriteNum of me to 1
  set the visible of sprite (the spriteNum of me - 2) to 1
  set StartX to the locH of sprite the spriteNum of me
  set StartY to the locV of sprite the spriteNum of me
  set DestX to the locH of sprite (the spriteNum of me - 2)
  set DestY to the locV of sprite (the spriteNum of me - 2)
end

on mouseDown me
  repeat while the stillDown = 1
    set X to the mouseH
    set Y to the mouseV
    if X > 289 then
      set X to 289
    end if
    if X < 280 then
      set X to 280
    end if
    if Y > 172 then
      set Y to 172
    end if
    if Y < 165 then
      set Y to 165
    end if
    set the loc of sprite the spriteNum of me to point(X, Y)
    set the loc of sprite (the spriteNum of me - 2) to point(((X - StartX) * 10) + DestX, ((Y - StartY) * 10) + DestY)
    updateStage()
  end repeat
end

on mouseUp me
end

on getBehaviorDescription
  return "Creates sprites that can be dropped on any other [user specified] sprite. You can define the target sprite, " && RETURN & "whether the dragged sprite snaps back to it's start position, and handlers to run if the drop was on or off target."
end
