property ItemState

on new me
  set the visible of sprite the spriteNum of me to 1
  set the visible of sprite (the spriteNum of me + 1) to 0
  set the visible of sprite (the spriteNum of me + 2) to ItemState
  set the visible of sprite (the spriteNum of me + 3) to ItemState
end

on mouseEnter me
  set the visible of sprite 86 to 0
  set the visible of sprite 87 to 0
  set the visible of sprite 88 to 0
  set the visible of sprite 89 to 0
  set the visible of sprite (the spriteNum of me + 1) to 1
end

on mouseLeave me
  set the visible of sprite 86 to 1
  set the visible of sprite 87 to 1
  set the visible of sprite 88 to 1
  set the visible of sprite 89 to 1
  set the visible of sprite (the spriteNum of me + 1) to 0
end

on mouseUp me
  set Seen to the visible of sprite (the spriteNum of me + 3)
  set the visible of sprite (the spriteNum of me + 2) to 1 - Seen
  set the visible of sprite (the spriteNum of me + 3) to 1 - Seen
end

on getBehaviorDescription
  return "Hilite a field for description. Second & third field are intended for toggling bitmaps (checkboxes and such). The paramitra is 1 for default on, 0 for default off."
end

on getPropertyDescriptionList
  set p_list to [#ItemState: [#default: ItemState, #format: #integer, #comment: "Initial state", #range: [#min: 0, #max: 1]]]
  return p_list
end
