property TargetSprite, startPos, correctspringBack, incorrectspringBack, incorrectvanish, correctvanish, IncorrectCommand, correctCommand, DescribeSprite
global Errorcount

on new me
  set the visible of sprite the spriteNum of me to 1
end

on mouseDown me
  set startPos to the loc of sprite the spriteNum of me
  repeat while the stillDown = 1
    set the loc of sprite the spriteNum of me to point(the mouseH, the mouseV)
    updateStage()
  end repeat
end

on mouseEnter me
  set the visible of sprite DescribeSprite to 1
end

on mouseLeave me
  set the visible of sprite DescribeSprite to 0
end

on mouseUp me
  if sprite the spriteNum of me intersects sprite(the TargetSprite of me) then
    do(the correctCommand of me)
    if the correctvanish of me = 1 then
      set the loc of sprite the spriteNum of me to point(1000, 1000)
      exit
    end if
    if the correctspringBack of me = 1 then
      set the loc of sprite the spriteNum of me to startPos
    end if
  else
    do(the IncorrectCommand of me)
  end if
  if the incorrectvanish of me = 1 then
    set the loc of sprite the spriteNum of me to point(1000, 1000)
    exit
  end if
  if the incorrectspringBack of me = 1 then
    set the loc of sprite the spriteNum of me to startPos
  end if
end

on getBehaviorDescription
  return "Creates sprites that can be dropped on any other [user specified] sprite. You can define the target sprite, " && RETURN & "whether the dragged sprite snaps back to it's start position, and handlers to run if the drop was on or off target."
end

on getPropertyDescriptionList
  if voidp(TargetSprite) then
    set TargetSprite to 1
  end if
  set p_list to [#TargetSprite: [#default: TargetSprite, #format: #integer, #comment: "Target Sprite Number", #range: [#min: 1, #max: 120]], #incorrectspringBack: [#default: 1, #format: #boolean, #comment: "Spring back when incorrect?"], #correctspringBack: [#default: 0, #format: #boolean, #comment: "Spring back when correct?"], #incorrectvanish: [#default: 0, #format: #boolean, #comment: "Vanish when dropped off the target?"], #correctvanish: [#default: 1, #format: #boolean, #comment: "Vanish when dropped on the target?"], #correctCommand: [#format: #string, #comment: "The handler to run if dropped on the target", #default: "beep"], #IncorrectCommand: [#format: #string, #comment: "The handler to run if dropped off the target", #default: "beep 2"], #DescribeSprite: [#default: 0, #format: #integer, #comment: "Description of sprite - appear on rollover, vanish on click", #range: [#min: 1, #max: 120]]]
  return p_list
end
